<script setup lang="ts">
    import { ref, watch } from 'vue'
    import { User } from '@/api/user/User'
    import { UserApi } from '@/api/user/UserApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import SUserListItem from '@/shared/administration/components/users/SUserListItem.vue'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { useRoleOptions } from '../../composables/users/useRoleOptions'
    import { useFilteredList } from '@/shared/search/composables/useFilteredList'
    import SearchField from '@/shared/search/components/SearchField.vue'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import { useSearchField } from '@/shared/search/composables/useSearchField'
    import RouteNavigationDrawer from '@/shared/administration/components/RouteNavigationDrawer.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import { toValue } from 'vue'

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const users = ref<User[]>([])

    const filterQuery = ref<string>('')
    const filteredUsers = useFilteredList<User>(
        users,
        filterQuery,
        (filterQuery: string) => {
            return (user: User) => {
                return user.email
                    .toLowerCase()
                    .includes(toValue(filterQuery).toLowerCase())
            }
        }
    )
    const searchField = ref<InstanceType<typeof SearchField>>()
    const { loseFocus, expanded, toggleExpanded } = useSearchField(searchField)

    const userApi = new UserApi(msal)

    const { loadRoleOptions, availableRoles } = useRoleOptions()

    const isLoading = ref(false)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            isLoading.value = true
            userApi
                .getAll()
                .then((returnedUsers) => (users.value = returnedUsers))
                .finally(() => (isLoading.value = false))
            loadRoleOptions(msal)
        },
        { immediate: true }
    )
</script>

<template>
    <route-navigation-drawer
        page-title="Utilisateurs"
        :show-title="searchField?.fullWidth"
    >
        <template #searchField>
            <search-field
                ref="searchField"
                v-model="filterQuery"
                :expanded="expanded"
                clearable
                @click:clear="filterQuery = ''"
                @click:icon="toggleExpanded"
                @focusout="loseFocus"
            />
        </template>
    </route-navigation-drawer>
    <v-main>
        <s-content-container>
            <h2 class="pt-3">{{ filteredUsers.length }} utilisateurs</h2>
            <v-skeleton-loader
                v-if="isLoading"
                type="heading, heading, heading"
            ></v-skeleton-loader>
            <v-list :lines="false">
                <template v-for="(user, index) in filteredUsers" :key="user.id">
                    <v-divider v-if="index > 0" />
                    <s-user-list-item
                        :available-roles="availableRoles"
                        :user="user"
                        :to="{
                            name: 'admin/utilisateurs/modifier',
                            params: {
                                id: user.id,
                            },
                        }"
                    />
                </template>
            </v-list>
            <s-action-button
                icon="mdi-plus"
                label="Ajouter un utilisateur"
                data-cy="save-user-button"
                display="floating-fixed"
                position="right"
                :to="{
                    name: 'admin/utilisateurs/creer',
                }"
            ></s-action-button>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
